datablock ItemData(ChestSuperMinigunItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./minigun chest2.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Super Minigun Chest Mounted";
	iconName = "./chest super minigun";
	doColorShift = true;
	colorShiftColor = "1.0 1.0 1.0 1.0";

	image = ChestSuperMinigunImage;
	canDrop = true;
};

function ChestSuperMinigunItem::onUse(%this, %obj, %slot)
{
	%obj.mountImage(%this.image, 0);
	%obj.playThread(1, root);
}

datablock ShapeBaseImageData(ChestSuperMinigunImage)
{
	shapeFile = "./minigun chest2.dts";
	emap = true;

	mountPoint = 2;
	offset = "0.0 0.74 -0.41";
	eyeOffset = "0 1.2 -1.2";
	rotation = eulerToMatrix("0 0 0");

	correctMuzzleVector = true;

	className = "WeaponImage";

	item = SuperMinigunItem;
	ammo = " ";
	projectile = gunProjectile;
	projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "-1.0 0 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

	melee = false;
	armReady = false;

	doColorShift = true;
	colorShiftColor = ChestSuperMinigunItem.colorShiftColor;

	stateName[0]					= "Activate";
	stateTimeoutValue[0]			= 0.15;
	stateTransitionOnTimeout[0]		= "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "SpinUp";
	stateAllowImageChange[1]        = true;
	stateSequence[1]				= "root";
	
	stateName[2]					= "SpinUp";
	stateTimeoutValue[2]			= 0.8;
	stateAllowImageChange[2]        = false;
	stateWaitForTimeout[2]			= true;
	stateSequence[2]				= "spin";
	stateTransitionOnTimeout[2]		= "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Smoke";
	stateTimeoutValue[3]            = 0.05;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= SuperMinigunFireEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= SuperMinigunFireSound;
	stateEjectShell[3]				= true;

	stateName[4]					= "Smoke";
	stateEmitter[4]					= gunSmokeEmitter;
	stateEmitterTime[4]				= 0.05;
	stateEmitterNode[4]				= "muzzleNode";
	stateTimeoutValue[4]            = 0.001;
	stateTransitionOnTriggerDown[4]	= "Fire";
	stateTransitionOnTriggerUp[4]	= "Ready";
	stateEjectShell[4]				= true;
};

function ChestSuperMinigunImage::onFire(%this, %obj, %slot)
{
	SuperMinigunImage::onFire(%this, %obj, %slot);
}

function ChestSuperMinigunImage::onUnMount(%this, %obj, %slot)
{
	Parent::onUnMount(%this, %obj, %slot);
}

package ChestMountedMinigun
{
	function serverCmdDropTool(%client, %slot)
	{
		if(isObject(%obj = %client.player) && %obj.tool[%slot] == ChestSuperMinigunItem.getId() && isObject(%image = %obj.getMountedImage(0)) && %image == ChestSuperMinigunImage.getId())
			%obj.unMountImage(0);
		
		Parent::serverCmdDropTool(%client, %slot);
	}
};
ActivatePackage(ChestMountedMinigun);