exec("./chest.cs");

datablock ItemData(SuperMinigunItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./minigun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Super Minigun";
	iconName = "./super minigun2";
	doColorShift = true;
	colorShiftColor = "1.0 1.0 1.0 1.0";

	image = SuperMinigunImage;
	canDrop = true;
};

datablock ShapeBaseImageData(SuperMinigunImage)
{
	shapeFile = "./minigun.dts";
	emap = true;
	
	mountPoint = 0;
	offset = "0.0 0.7 -0.72";
	// eyeOffset = "0 1.7 -1.8";
	eyeOffset = 0;
	rotation = eulerToMatrix("0 0 0");
	
	correctMuzzleVector = true;
	
	className = "WeaponImage";
	
	item = SuperMinigunItem;
	ammo = " ";
	projectile = gunProjectile;
	projectileType = Projectile;
	
	casing = gunShellDebris;
	shellExitDir        = "-1.0 0 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;
	
	melee = false;
	armReady = true;
	
	doColorShift = true;
	colorShiftColor = SuperMinigunItem.colorShiftColor;
	
	stateName[0]					= "Activate";
	stateTimeoutValue[0]			= 0.15;
	stateTransitionOnTimeout[0]		= "Ready";
	stateSound[0]					= weaponSwitchSound;
	
	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "SpinUp";
	stateAllowImageChange[1]        = true;
	stateSequence[1]				= "root";
	
	stateName[2]					= "SpinUp";
	stateTimeoutValue[2]			= 0.8;
	stateAllowImageChange[2]        = false;
	stateWaitForTimeout[2]			= true;
	stateSequence[2]				= "spin";
	stateTransitionOnTimeout[2]		= "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	
	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Smoke";
	stateTimeoutValue[3]            = 0.05;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= SuperMinigunFireEmitter;
	stateEmitterTime[3]				= 0.06;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= SuperMinigunFireSound;
	stateEjectShell[3]				= true;
	
	stateName[4]					= "Smoke";
	stateEmitter[4]					= gunSmokeEmitter;
	stateEmitterTime[4]				= 0.05;
	stateEmitterNode[4]				= "muzzleNode";
	stateTimeoutValue[4]            = 0.001;
	stateTransitionOnTriggerDown[4]	= "Fire";
	stateTransitionOnTriggerUp[4]	= "Ready";
	stateEjectShell[4]				= true;
};

function SuperMinigunImage::onFire(%this, %obj, %slot)
{
	%obj.playThread(0, plant);
	
	%fvec = %obj.getForwardVector();
	%fX = getWord(%fvec, 0);
	%fY = getWord(%fvec, 1);
	
	%evec = %obj.getEyeVector();
	%eX = getWord(%evec, 0);
	%eY = getWord(%evec, 1);
	%eZ = getWord(%evec, 2);
	
	%eXY = mSqrt(%eX*%eX + %eY*%eY);
	
	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
	
	%start = %obj.getEyePoint();
	%end = VectorAdd(%obj.getEyePoint(), VectorScale(%aimVec, 500));
	%raycast = ContainerRaycast(%start, %end, $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::FxBrickObejctType | $TypeMasks::TerrainObjectType, %obj);
	
	if(isObject(getWord(%raycast, 0)))
		%vector = VectorNormalize(VectorSub(getWords(%raycast, 1, 3), %obj.getMuzzlePoint(%slot)));
	else
		%vector = %obj.getMuzzleVector(%slot);
	
	%spread = 0.004;
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %vector);
	%velocity = VectorNormalize(%velocity);
	
	%p = new Projectile()
	{
	 	datablock = SuperMinigunProjectile;
	 	initialPosition = %obj.getMuzzlePoint(%slot);
	 	initialVelocity = VectorScale(%velocity, 180);
	 	sourceObject = %obj;
	 	sourceSlot = %slot;
	 	client = %obj.client;
	};
}