ForceRequiredAddOn("Weapon_Gun");

datablock AudioProfile(SuperMinigunFireSound)
{
	filename    = "./minigun.wav";
	description = AudioClosest3d;
	preload = true;
};

datablock ParticleData(SuperMinigunFireParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 49;
	textureName          = "base/data/particles/star1";
	spinSpeed        = 0.0;
	spinRandomMin        = -10000.0;
	spinRandomMax        = 10000.0;

	colors[0]     = "1.0 0.5 0 0.9";
	colors[1]     = "0.9 0.4 0 0.8";
	colors[2]     = "1 0.5 0.2 0.6";
	colors[3]     = "1 0.5 0.2 0.4";

	sizes[0]      = 3.25;
	sizes[1]      = 0.8;
	sizes[2]      = 0.1;
	sizes[3]      = 0.0;

	times[0] = 0.0;
	times[1] = 0.1;
	times[2] = 0.5;
	times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SuperMinigunFireEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 120.0;
	velocityVariance = 25.0;
	ejectionOffset   = 0.0;
	thetaMin         = 0;
	thetaMax         = 1;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;

	particles = SuperMinigunFireParticle;
};

datablock ParticleData(SuperMinigunTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 80;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;

	textureName		= "base/data/particles/cloud";

	colors[0]	= "1 1 0 0.1";
	colors[1]	= "1 1 0.4 0.08";
	colors[2]	= "0.7 0.7 0.7 0";
	
	sizes[0]	= 0.4;
	sizes[1]	= 0.3;
	sizes[2]	= 0.0;
	
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};
datablock ParticleEmitterData(SuperMinigunTrailEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 0; //0.25;
	velocityVariance = 0; //0.10;
	ejectionOffset = 0;
	thetaMin         = 0.0;
	thetaMax         = 90.0;  

	particles = SuperMinigunTrailParticle;
};

AddDamageType("SuperMinigun", '<bitmap:Add-Ons/Weapon_SuperMinigun/ci_super_minigun> %1', '%2 <bitmap:Add-Ons/Weapon_SuperMinigun/ci_super_minigun> %1', 0.2, 1);
datablock ProjectileData(SuperMinigunProjectile : gunProjectile)
{
	directDamage        = 8;
	directDamageType    = $DamageType::SuperMinigun;
	radiusDamageType    = $DamageType::SuperMinigun;

	impactImpulse	     = 100;
	verticalImpulse	  = 50;
	explosion           = gunExplosion;
	particleEmitter     = SuperMinigunTrailEmitter;

	muzzleVelocity      = 180;
	velInheritFactor    = 0;

	armingDelay         = 00;
	lifetime            = 6000;
	fadeDelay           = 5500;
	bounceElasticity    = 0.5;
	bounceFriction      = 0.20;
	isBallistic         = true;
	gravityMod = 0.5;

	hasLight    = false;
	lightRadius = 3.0;
	lightColor  = "0 0 0.5";
};

exec("./normal.cs");
exec("./chest.cs");